package handwriting.learners.som;

import handwriting.core.Drawing;
import javafx.scene.canvas.Canvas;
import javafx.scene.paint.Color;

public interface SelfOrgMap {
	
	// Return the best matching node for "example"
	public SOMPoint bestFor(Drawing example);
	
	// Train SOM using "example"
	public void train(Drawing example);
	
	// Return the correct color for pixel (x, y) at node
	public Color getFillFor(int x, int y, SOMPoint node);

	public int getMapWidth();
	public int getMapHeight();
	
	public int getDrawingWidth();
	public int getDrawingHeight();
	
	default public boolean isLegal(SOMPoint point) {
		return point.x() >= 0 && point.x() < getMapWidth() && point.y() >= 0 && point.y() < getMapHeight();
	}
	
	default public void visualize(Canvas surface) {
		Visualizer vis = new Visualizer(surface, this);
		vis.visualizeSOM();
	}
}
