package handwriting.learners.som;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;

public class Visualizer {
	private double cellWidth, cellHeight, pixWidth, pixHeight;
	private GraphicsContext g;
	private SelfOrgMap som;
	
	public Visualizer(Canvas surface, SelfOrgMap som) {
		g = surface.getGraphicsContext2D();
		cellWidth = surface.getWidth() / som.getMapWidth();
		cellHeight = surface.getHeight() / som.getMapHeight();
		pixWidth = cellWidth / som.getDrawingWidth();
		pixHeight = cellHeight / som.getDrawingHeight();
		this.som = som;
	}
	
	public void visualizeSOM() {
		for (int x = 0; x < som.getMapWidth(); x++) { 
			for (int y = 0; y < som.getMapHeight(); y++) {
				visualizeCell(new SOMPoint(x, y));
			}
		}
	}
	
	private void visualizeCell(SOMPoint cell) {
		for (int x = 0; x < som.getDrawingWidth(); x++) {
			for (int y = 0; y < som.getDrawingHeight(); y++) {
				g.setFill(som.getFillFor(x, y, cell));
				g.fillRect(cellWidth * cell.x() + pixWidth * x, cellHeight * cell.y() + pixHeight * y, pixWidth, pixHeight);
			}
		}
	}
}
